'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _pg = require('pg');

var _pg2 = _interopRequireDefault(_pg);

var _url = require('url');

var _url2 = _interopRequireDefault(_url);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Postgres = function () {
  function Postgres(options) {
    (0, _classCallCheck3.default)(this, Postgres);

    var params = _url2.default.parse(options.url);
    var auth = params.auth.split(':');

    var config = {
      user: auth[0],
      password: auth[1],
      host: params.hostname,
      port: params.port,
      database: params.pathname.split('/')[1],
      ssl: options.ssl || false,
      max: 1,
      idleTimeoutMillis: 60000
    };
    this._db = new _pg2.default.Pool(config);
  }

  (0, _createClass3.default)(Postgres, [{
    key: 'createHealthCheck',
    value: function createHealthCheck() {
      var _this = this;

      return function () {
        var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(callback) {
          var result;
          return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.prev = 0;
                  _context.next = 3;
                  return _this._db.query('SELECT 1 as one');

                case 3:
                  result = _context.sent;

                  if (result.rows[0].one === 1) {
                    callback(null, 'Database is available');
                  } else {
                    callback(true, 'Database is unavailable');
                  }
                  _context.next = 11;
                  break;

                case 7:
                  _context.prev = 7;
                  _context.t0 = _context['catch'](0);

                  console.error('error in Postgres health check: ' + _context.t0);
                  callback(true, 'Error when accessing the database');

                case 11:
                case 'end':
                  return _context.stop();
              }
            }
          }, _callee, _this, [[0, 7]]);
        }));

        return function (_x) {
          return _ref.apply(this, arguments);
        };
      }();
    }
  }]);
  return Postgres;
}();

exports.default = Postgres;